{El juego de las Torres de Hanoi fue inventado a fines del siglo XIX y es un problema interesante para resolver de forma recursiva. Consiste en tres pilas (o varillas) verticales denominadas origen, destino y auxiliar. En la pila de origen hay un nmero n de discos, dispuestos de mayor a menor tamao, como se muestra en la figura siguiente: El objetivo del rompecabezas es mover todos los discos desde la pila de origen hacia la de destino, haciendo uso de la varilla auxiliar. Aunque su solucin parezca trivial, deben respetarse las reglas que siguen:}
{Slo podr desplazarse el disco que se encuentre en el tope de la pila.}
{En ningn momento podr haber un disco de mayor tamao sobre otro ms pequeo.}
{Los discos estn numerados desde 1 hasta n (el disco 1 es el ms pequeo, y el n, el ms grande).}
{Se recomienda que, luego de analizar este caso, el lector implemente la solucin a este problema de manera iterativa (no recursiva) mediante estructuras de control repetitivas.}
{Solucin en lenguaje Pascal}

PROGRAM cap09_ej03;
CONST ORIGEN = 1;
CONST DESTINO = 2;
CONST AUXILIAR = 3;

PROCEDURE hanoi(cant_discos, origen, destino, auxiliar: INTEGER);

BEGIN
	IF (cant_discos > 0) THEN
	BEGIN
	{ Se mueven todos los discos, salvo el de ms abajo, }
	{ a la pila auxiliar }
	hanoi(cant_discos - 1, origen, auxiliar, destino);

	{ Una vez que qued libre, se mueve el ltimo }
	{ disco a la pila de destino }
	WRITELN('Moviendo disco ', cant_discos, ' desde la pila ', origen, ' hacia la pila ', destino);
	{ Por ltimo se mueven todos los discos que estaban (temporalmente) en }
	{ la pila auxiliar hacia la pila de destino. }
	hanoi(cant_discos - 1, auxiliar, destino, origen);
	END;
END;

VAR cant_discos: INTEGER;

{ Programa Principal }
BEGIN
	WRITELN('Juego de las Torres de Hanoi');
	WRITELN('****************************');

	WRITE('Ingrese la cantidad de discos: ');
	READLN(cant_discos);
	IF (cant_discos > 0) THEN
	BEGIN
		hanoi(cant_discos, ORIGEN, DESTINO, AUXILIAR);
		WRITELN('FIN DEL ROMPECABEZAS!');
		WRITELN;
	END
	ELSE
	BEGIN
	WRITELN('La cantidad de discos a utilizar debe ser mayor que cero!');
	END;
END.