/* 4- Localice un entero en un arreglo usando una versin recursiva del algoritmo de bsqueda binaria. El nmero que se debe buscar (clave) se debe ingresar como argumento por lnea de comandos. El arreglo de datos debe estar previamente ordenado (requisito de la bsqueda binaria). Comparar esta versin recursiva de la bsqueda binaria con la versin iterativa dada en el captulo 5.*/
/* Solucin en lenguaje C*/

#include <stdio.h>
#include <stdlib.h>

#define N 10

typedef int t_arreglo_enteros[N];

/* Prototipo */
int buscar(int clave, t_arreglo_enteros datos, int inferior, int superior);

/* Programa Principal */
int main(int argc, char *argv[])
{
	t_arreglo_enteros datos = { 3 , 4 , 6 , 12 , 13 , 17 , 19 , 24 , 29 , 30 };
	int pos;
	if (argc != 2)
	{
		printf("Modo de uso: %s <clave a buscar>\n", argv[0]);
		return 1;
	}

	/* Bsqueda */
	pos = buscar(atoi(argv[1]), datos, 0, N-1);

	if (pos != -1)
		printf("El entero %d se encontr en la posicin %d\n", atoi(argv[1]),pos);
	else
		printf("El entero %d no pudo encontrarse\n", atoi(argv[1]));
	return 0;
}

int buscar(int clave, t_arreglo_enteros datos, int inferior, int superior)
{
	int centro;
	/* Si el dato no se encuentra, retorna -1 */
	if (inferior > superior)
		return -1;

	centro = (inferior + superior) / 2; /* Divisin entera */

	if (datos[centro] == clave)
		return centro;
	else
		if (datos[centro] > clave)
			return buscar(clave, datos, inferior, centro-1);
		else
			return buscar(clave, datos, centro+1, superior);
}